# The Nimbus Fluffy Guide

Fluffy is the Nimbus client implementation of the
[Portal network specifications](https://github.com/ethereum/portal-network-specs).

The Portal Network aims to deliver a reliable, sync-free, and decentralized
access to the Ethereum blockchain. The network can be used by a light client to
get access to Ethereum data and as such become a drop-in replacement for full
nodes by providing that data through the existing
[Ethereum JSON RPC Execution API](https://github.com/ethereum/execution-apis).

This book describes how to build, run and monitor the Fluffy client, and how to
use and test its currently implemented functionality.

To quickly get your Fluffy node up and running, follow the quickstart page:

  - [Quickstart for Linux / macOS users](./quick-start.md)
  - [Quickstart for Windows users](./quick-start-windows.md)

# Development status
The Portal Network is a project still in research phase.
This client is thus still experimental.

However, the Portal history and Portal beacon sub-networks are already operational and can be tested on the public testnet or in a local testnet.

## Get in touch

Need help with anything?
Join us on [Status](https://join.status.im/nimbus-general) and [Discord](https://discord.gg/9dWwPnG).

## Donate

If you'd like to contribute to Nimbus development:

* Our donation address is [`0xDeb4A0e8d9a8dB30a9f53AF2dCc9Eb27060c6557`](https://etherscan.io/address/0xDeb4A0e8d9a8dB30a9f53AF2dCc9Eb27060c6557)
* We're also listed on [GitCoin](https://gitcoin.co/grants/137/nimbus-2)

## Disclaimer

This documentation assumes Nimbus Fluffy is in its ideal state.
The project is still under heavy development.
Please submit a [Github issue](https://github.com/status-im/nimbus-eth1/issues) if you come across a problem.